=== debian/changelog ===
yade (1.05.0-2~bpo70+1) wheezy-backports; urgency=low

  * Rebuild for wheezy-backports.
  * Remove python-gts, libmetis-dev and python-minieigen from Build-Depends.
  * Replace libqglviewer-dev by libqglviewer-qt4-dev.

 -- Anton Gladky <gladk@debian.org>  Tue, 03 Dec 2013 20:47:54 +0100

yade (1.05.0-2) unstable; urgency=low

  * [cf3f8d9] Pass -ftrack-macro-expansion=0 only if gcc>=4.8. (Closes: #726009)

 -- Anton Gladky <gladk@debian.org>  Wed, 30 Oct 2013 20:56:33 +0100

yade (1.05.0-1) unstable; urgency=low

  * [8448883] Imported Upstream version 1.05.0
  * [82b3047] Do not use clang explicitly.
  * [2f28ccc] Remove -ftrack-macro-expansion=0 option.

 -- Anton Gladky <gladk@debian.org>  Mon, 28 Oct 2013 20:55:21 +0100

yade (1.00.0-5) unstable; urgency=low

  * [b4d2aa3] Use clang on archs, where gcc fails. (Closes: #726009)

 -- Anton Gladky <gladk@debian.org>  Sat, 26 Oct 2013 22:25:21 +0200

yade (1.00.0-4) unstable; urgency=low

  * [91cd9f0] Set explicitly gcc-4.8 as the compiler for some archs. 
              Thanks to  Peter Green <plugwash@p10link.net>. (Closes: #726009)

 -- Anton Gladky <gladk@debian.org>  Thu, 24 Oct 2013 18:27:26 +0200

yade (1.00.0-3) unstable; urgency=low

  * [d386d37] Add libbz2-dev and zlib1g-dev to BD.
  * [dd8d977] Disable Release-Mode in Cmake, pass -ftrack-macro-expansion=0 to
              reduce RAM-consumption during compilation. (Closes: #726009)
  * [1942de7] Ignore quilt dir.
  * [de26aa7] Unapply patches after build.

 -- Anton Gladky <gladk@debian.org>  Tue, 15 Oct 2013 19:32:33 +0200

yade (1.00.0-2) unstable; urgency=low

  * [2b4cc97] Disable parallel build (fails due to RAM consumption).

 -- Anton Gladky <gladk@debian.org>  Tue, 01 Oct 2013 19:14:48 +0200

yade (1.00.0-1) unstable; urgency=low

  * [bbab763] Update debian/watch. Take version number from github.
  * [1c35234] Remove binutils-gold. (Closes: #722544)
  * [eb29103] Add BD for new PFV-feature.
  * [27ffe4a] Update break/replaces for older yade versions.
  * [6b2b68f] Remove mencoder from recommends.
  * [fe54741] Add system-component of boost to be linked.
  * [39b346a] Override lintian error (seems, false-positive).
  * [9edd741] Use canonical VCS-field.
  * [b3f639e] Imported Upstream version 1.00.0

 -- Anton Gladky <gladk@debian.org>  Mon, 30 Sep 2013 19:20:42 +0200
