## yade 1.07.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -39,25 +39,46 @@
 INCLUDE(FindPythonModule)
 INCLUDE(GNUInstallDirs)
 #===========================================================
+# HACK!!! If the version of gcc is 4.8 or greater, we add -ftrack-macro-expansion=0 
+# and -save-temps into compiler to reduce the memory consumption during compilation.
+# See http://bugs.debian.org/726009 for more information
+# Can be removed later, if gcc fixes its regression
+# Taken from http://stackoverflow.com/questions/4058565/check-gcc-minor-in-cmake
+ 
+EXECUTE_PROCESS(COMMAND ${CMAKE_C_COMPILER} -dumpversion OUTPUT_VARIABLE GCC_VERSION)
+IF (GCC_VERSION VERSION_GREATER 4.8 OR GCC_VERSION VERSION_EQUAL 4.8)
+  MESSAGE(STATUS "GCC Version >= 4.8. Adding -ftrack-macro-expansion=0 and -save-temps")
+  SET(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -ftrack-macro-expansion=0 -save-temps")
+ENDIF()
+
+#===========================================================
+
+IF ("${CMAKE_CXX_COMPILER} ${CMAKE_CXX_COMPILER_ARG1}" MATCHES ".*clang")
+  SET(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -ftemplate-depth-512")
+ENDIF()
+
+#===========================================================
+ADD_DEFINITIONS(" -DYADE_PTR_CAST=static_pointer_cast -DYADE_CAST=static_cast ")
 IF (CMAKE_CXX_FLAGS)
   #If flags are set, add only neccessary flags
   IF (DEBUG)
     SET(CMAKE_VERBOSE_MAKEFILE 1)
     SET(CMAKE_BUILD_TYPE Debug)
-    SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -DYADE_PTR_CAST=static_pointer_cast -DYADE_CAST=static_cast -DYADE_DEBUG")
+    ADD_DEFINITIONS("-DYADE_DEBUG")
   ELSE (DEBUG)
     SET(CMAKE_BUILD_TYPE Release)
-    SET(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -DYADE_PTR_CAST=static_pointer_cast -DYADE_CAST=static_cast -fPIC")
+    SET(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -fPIC")
   ENDIF (DEBUG)
 ELSE (CMAKE_CXX_FLAGS)
   #If flags are not set, add all useful flags
   IF (DEBUG)
     SET(CMAKE_VERBOSE_MAKEFILE 1)
     SET(CMAKE_BUILD_TYPE Debug)
-    SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG}  -DYADE_PTR_CAST=static_pointer_cast -DYADE_CAST=static_cast -DYADE_DEBUG -Wall -fPIC -g -fstack-protector --param=ssp-buffer-size=4 -Wformat -Wformat-security -Werror=format-security")
+    ADD_DEFINITIONS("-DYADE_DEBUG")
+    SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -Wall -fPIC -g -fstack-protector --param=ssp-buffer-size=4 -Wformat -Wformat-security -Werror=format-security")
   ELSE (DEBUG)
     SET(CMAKE_BUILD_TYPE Release)
-    SET(CMAKE_CXX_FLAGS  "-DYADE_PTR_CAST=static_pointer_cast -DYADE_CAST=static_cast -Wall -fPIC -g -O2 -fstack-protector --param=ssp-buffer-size=4 -Wformat -Wformat-security -Werror=format-security -s")
+    SET(CMAKE_CXX_FLAGS  "-Wall -fPIC -g -O2 -fstack-protector --param=ssp-buffer-size=4 -Wformat -Wformat-security -Werror=format-security -s")
   ENDIF (DEBUG)
 ENDIF (CMAKE_CXX_FLAGS)
 #===========================================================
@@ -109,7 +130,7 @@
 SET(LINKLIBS  "${LINKLIBS};${BZIP2_LIBRARIES};${ZLIB_LIBRARIES};")
 #===========================================================
 IF(ENABLE_VTK)
-  FIND_PACKAGE(VTK COMPONENTS Common) 
+  FIND_PACKAGE(VTK) 
   IF(VTK_FOUND)
     INCLUDE_DIRECTORIES(${VTK_INCLUDE_DIRS})
     LINK_DIRECTORIES( ${VTK_LIBRARY_DIRS} )
@@ -244,7 +265,7 @@
     MESSAGE(STATUS "Found Metis")
     SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} LinSolv")
   ELSE(CHOLMOD_FOUND AND OPENBLAS_FOUND AND METIS_FOUND)
-    MESSAGE(STATUS "CHOLMOD NOT found, LINSOLV disabled")
+    MESSAGE(STATUS "Missing dependency for LINSOLV, disabled")
     SET(DISABLED_FEATS "${DISABLED_FEATS} LinSolv")
     SET(ENABLE_LINSOLV OFF)
   ENDIF(CHOLMOD_FOUND AND OPENBLAS_FOUND AND METIS_FOUND)
@@ -260,23 +281,3 @@
     SET(LINKLIBS  "${LINKLIBS};${GL2PS_LIBRARIES};")
     MESSAGE(STATUS "Found GL2PS")
     SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} GL2PS")
-  ELSE(GL2PS_FOUND)
-    MESSAGE(STATUS "GL2PS NOT found")
-    SET(DISABLED_FEATS "${DISABLED_FEATS} GL2PS")
-    SET(ENABLE_GL2PS OFF)
-  ENDIF(GL2PS_FOUND)
-ELSE(ENABLE_GL2PS)
-  SET(DISABLED_FEATS "${DISABLED_FEATS} GL2PS")
-ENDIF(ENABLE_GL2PS)
-
-INCLUDE_DIRECTORIES(${PYTHON_INCLUDE_DIRS})
-INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/extra/floating_point_utilities_v3)
-INCLUDE_DIRECTORIES(${CMAKE_BINARY_DIR})
-
-#===========================================================
-
-IF (NOT INSTALL_PREFIX)
- SET(CMAKE_INSTALL_PREFIX "/usr/local")
- MESSAGE("Yade will be installed to default path ${CMAKE_INSTALL_PREFIX}, if you want to override it use -DINSTALL_PREFIX option.")
-ELSE (NOT INSTALL_PREFIX)
-	GET_FILENAME_COMPONENT(CMAKE_INSTALL_PREFIX ${INSTALL_PREFIX} ABSOLUTE)
