=== debian/changelog ===
yade (1.07.0-2) unstable; urgency=medium

  * [1de8256] Increase number of steps in checkWeight.py.

 -- Anton Gladky <gladk@debian.org>  Sun, 19 Jan 2014 19:59:34 +0100

yade (1.07.0-1) unstable; urgency=medium

  * [d42c7de] Imported Upstream version 1.07.0
  * [a421b10] Remove patch, applied by upstream.
  * [d151f88] Set Standards-Version: 3.9.5. No changes.
  * [a9616c6] Add upstream file.
  * [c078bb4] Inject additional parameters for weak archs. 
              Thanks to Roland Stigge <stigge@antcom.de>. (Closes: #733152)
  * [21a2430] Fix version definition for IPython>1.0.0.
  * [8204093] Remove google-scripts from documentation.

 -- Anton Gladky <gladk@debian.org>  Mon, 13 Jan 2014 20:13:14 +0100
