=== debian/control ===
--- 
+++ 
@@ -20,15 +20,20 @@
  libgl1-mesa-dev,
  libgts-dev,
  libloki-dev,
- libqglviewer-qt4-dev,
+ libmetis-dev [amd64 i386 ia64 kfreebsd-amd64 kfreebsd-i386 powerpc],
+ libopenblas-dev [amd64 i386 ia64 kfreebsd-amd64 kfreebsd-i386 powerpc],
+ libqglviewer-dev,
+ libsuitesparse-dev [amd64 i386 ia64 kfreebsd-amd64 kfreebsd-i386 powerpc],
  libvtk5-dev,
  libxi-dev,
  libxmu-dev,
  pyqt4-dev-tools,
  python-all-dev (>= 2.6.6-3~),
  python-argparse,
+ python-gts,
  python-imaging,
  python-matplotlib,
+ python-minieigen [!s390],
  python-numpy,
  python-qt4,
  python-support,
@@ -48,7 +53,7 @@
  texlive-pictures,
  texlive-xetex,
  tipa
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 
 Package: yade
 Architecture: any
@@ -109,8 +114,10 @@
 Depends:
  libyade (= ${binary:Version}),
  python-argparse,
+ python-gts,
  python-imaging,
  python-matplotlib,
+ python-minieigen,
  python-qt4,
  python-tk,
  python-xlib,
