=== debian/rules ===
--- 
+++ 
@@ -7,6 +7,11 @@
 	dh $@ --buildsystem=cmake --builddirectory=$(BUILDDIR) --with python2
 
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed,-no-keep-memory
+
+# Theses flags are neccessry for weak archs. See #733152
+ifneq (,$(filter $(DEB_HOST_ARCH), armel armhf hurd-i386 mips mipsel))
+	export DEB_CXXFLAGS_MAINT_APPEND = --param ggc-min-expand=20 --param ggc-min-heapsize=128000
+endif
 
 export MPLCONFIGDIR := $(tmpDirMatplotLib) 
 export HOME := $(tmpDirMatplotLib)
