## yade 1.10.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -14,9 +14,13 @@
 #  ENABLE_GL2PS: enable GL2PS-option (ON by default)
 #  ENABLE_LINSOLV: enable LINSOLV-option (ON by default)
 #  ENABLE_PFVFLOW: enable PFVFLOW-option, FlowEngine (ON by default)
+#  ENABLE_SPH: enable SPH-option, Smoothed Particle Hydrodynamics (OFF by default, experimental)
+#  ENABLE_LBMFLOW: enable LBMFLOW-option, LBM_ENGINE (OFF by default)
+#  ENABLE_LIQMIGRATION: enable LIQMIGRATION-option, see [Mani2013] for details (OFF by default)
+#  ENABLE_MASK_ARBITRARY: enable MASK_ARBITRARY option (OFF by default)
 #  runtimePREFIX: used for packaging, when install directory is not the same is runtime directory (/usr/local by default)
 #  CHUNKSIZE: set >1, if you want several sources to be compiled at once. Increases compilation speed and RAM-consumption during it (1 by default).
-
+#  VECTORIZE: enables vectorization and alignment in Eigen3 library, experimental (OFF by default)
 
 project(Yade C CXX)
 cmake_minimum_required(VERSION 2.8)
@@ -58,7 +62,7 @@
 ENDIF()
 
 #===========================================================
-ADD_DEFINITIONS(" -DYADE_PTR_CAST=static_pointer_cast -DYADE_CAST=static_cast ")
+ADD_DEFINITIONS(" -DYADE_PTR_CAST=boost::static_pointer_cast -DYADE_CAST=static_cast ")
 IF (CMAKE_CXX_FLAGS)
   #If flags are set, add only neccessary flags
   IF (DEBUG)
@@ -84,7 +88,10 @@
 #===========================================================
 # Add possibility to use local boost installation (e.g. -DLocalBoost=1.46.1)
 
-FIND_PACKAGE(Boost ${LocalBoost} COMPONENTS python thread date_time filesystem iostreams regex serialization system REQUIRED)
+IF ( NOT LocalBoost )
+  SET(LocalBoost "1.35.0") # Minimal required Boost version
+ENDIF ( NOT LocalBoost )
+FIND_PACKAGE(Boost ${LocalBoost} COMPONENTS python thread filesystem iostreams regex serialization system date_time REQUIRED)
 INCLUDE_DIRECTORIES (${Boost_INCLUDE_DIRS})
 # for checking purpose
 MESSAGE("--   Boost_VERSION: " ${Boost_VERSION})
@@ -116,18 +123,46 @@
 OPTION(ENABLE_GL2PS "Enable GL2PS" ${DEFAULT})
 OPTION(ENABLE_LINSOLV "Enable direct solver for the flow engines (experimental)" ${DEFAULT})
 OPTION(ENABLE_PFVFLOW "Enable flow engine (experimental)" ${DEFAULT})
+OPTION(ENABLE_SPH "Enable SPH" OFF)
+OPTION(ENABLE_LBMFLOW "Enable LBM engine (very experimental)" OFF)
+OPTION(ENABLE_LIQMIGRATION "Enable liquid control (very experimental), see [Mani2013] for details" OFF)
+OPTION(ENABLE_MASK_ARBITRARY "Enable arbitrary precision of bitmask variables (only Body::groupMask yet implemented) (experimental). Use -DMASK_ARBITRARY_SIZE=int to set number of used bits (256 by default)" OFF)
 
 #===========================================================
 # Use Eigen3 by default
 IF (EIGEN3_FOUND)
   INCLUDE_DIRECTORIES(${EIGEN3_INCLUDE_DIR})
-  MESSAGE(STATUS "Found Eigen3")
+  MESSAGE(STATUS "Found Eigen3, version: ${EIGEN3_VERSION}")
+  
+  # Minimal recommended version 3.2.1
+  IF ((${EIGEN3_MAJOR_VERSION} LESS 2) OR ((${EIGEN3_MAJOR_VERSION} EQUAL 2) AND (${EIGEN3_MINOR_VERSION} LESS 1)))
+    MESSAGE(WARNING "Minimal recommended Eigen3 version is 3.2.1")
+  ENDIF ((${EIGEN3_MAJOR_VERSION} LESS 2) OR ((${EIGEN3_MAJOR_VERSION} EQUAL 2) AND (${EIGEN3_MINOR_VERSION} LESS 1)))
+
   SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} Eigen3")
+  IF (NOT VECTORIZE)
+    MESSAGE(STATUS "Disable vectorization")
+    ADD_DEFINITIONS("-DEIGEN_DONT_VECTORIZE -DEIGEN_DONT_ALIGN -DEIGEN_DISABLE_UNALIGNED_ARRAY_ASSERT")
+  ELSE (NOT VECTORIZE)
+    MESSAGE(STATUS "Enable vectorization")
+  ENDIF (NOT VECTORIZE)
+  
 ENDIF(EIGEN3_FOUND)
 #===========================================================
 INCLUDE_DIRECTORIES(${BZIP2_INCLUDE_DIR})
 INCLUDE_DIRECTORIES(${ZLIB_INCLUDE_DIRS})
 SET(LINKLIBS  "${LINKLIBS};${BZIP2_LIBRARIES};${ZLIB_LIBRARIES};")
+#===========================================================
+IF((Boost_MAJOR_VERSION EQUAL 1) OR (Boost_MAJOR_VERSION GREATER 1) AND
+  ((Boost_MINOR_VERSION EQUAL 53) OR (Boost_MINOR_VERSION GREATER 53)))
+  SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} Odeint")
+  ADD_DEFINITIONS("-DYADE_ODEINT")
+ELSE((Boost_MAJOR_VERSION EQUAL 1) OR (Boost_MAJOR_VERSION GREATER 1) AND
+    ((Boost_MINOR_VERSION EQUAL 53) OR (Boost_MINOR_VERSION GREATER 53)))
+  SET(DISABLED_FEATS "${DISABLED_FEATS} Odeint")
+  MESSAGE(STATUS "Boost Odeint can be enabled, only if Boost>=1.53 is used")
+ENDIF((Boost_MAJOR_VERSION EQUAL 1) OR (Boost_MAJOR_VERSION GREATER 1) AND
+     ((Boost_MINOR_VERSION EQUAL 53) OR (Boost_MINOR_VERSION GREATER 53)))
 #===========================================================
 IF(ENABLE_VTK)
   FIND_PACKAGE(VTK) 
@@ -135,7 +170,6 @@
     INCLUDE_DIRECTORIES(${VTK_INCLUDE_DIRS})
     LINK_DIRECTORIES( ${VTK_LIBRARY_DIRS} )
     SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DYADE_VTK")
-    SET(features "${features} vtk")
     MESSAGE(STATUS "Found VTK")
     SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} VTK")
   ELSE(VTK_FOUND)
@@ -153,7 +187,6 @@
     SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DYADE_OPENMP ${OpenMP_CXX_FLAGS}")
     MESSAGE(STATUS "Found OpenMP")
     SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} OpenMP")
-    SET(features "${features} openmp")
   ELSE(OPENMP_FOUND)
     MESSAGE(STATUS "OpenMP NOT found")
     SET(ENABLE_OPENMP OFF)
@@ -173,7 +206,6 @@
     INCLUDE_DIRECTORIES(${GLIB2_INCLUDE_DIRS})
     MESSAGE(STATUS "Found GTS")
     SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} GTS")
-    SET(features "${features} gts")
   ELSE(GTS_FOUND AND GLIB2_FOUND)
     MESSAGE(STATUS "GTS NOT found")
     SET(DISABLED_FEATS "${DISABLED_FEATS} GTS")
@@ -192,7 +224,6 @@
   IF(QT4_FOUND AND OPENGL_FOUND AND GLUT_FOUND AND GLIB2_FOUND AND QGLVIEWER_FOUND)
     SET(GUI_LIBS ${GLUT_LIBRARY} ${OPENGL_LIBRARY} ${QGLVIEWER_LIBRARIES})
     SET(GUI_SRC_LIB "lib/opengl/GLUtils.cpp")
-    SET(features "${features} qt4 opengl")
     SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DYADE_OPENGL")
     INCLUDE_DIRECTORIES(${GLIB2_INCLUDE_DIRS})
     INCLUDE_DIRECTORIES(${QT_INCLUDES})
@@ -232,52 +263,3 @@
     SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} CGAL")
 
     IF(ENABLE_PFVFLOW)
-      SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DFLOW_ENGINE")
-      SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} PFVflow")
-    ELSE(ENABLE_PFVFLOW)
-      SET(DISABLED_FEATS "${DISABLED_FEATS} PFVflow")
-    ENDIF(ENABLE_PFVFLOW)
-
-  ELSE(CGAL_FOUND AND GMP_FOUND AND (NOT("${CMAKE_CXX_COMPILER} ${CMAKE_CXX_COMPILER_ARG1}" MATCHES ".*clang")))
-    MESSAGE(STATUS "CGAL NOT found")
-    SET(DISABLED_FEATS "${DISABLED_FEATS} CGAL")
-    SET(ENABLE_CGAL OFF)
-    IF(ENABLE_PFVFLOW)
-      SET(DISABLED_FEATS "${DISABLED_FEATS} PFVflow")
-      MESSAGE(STATUS "CGAL NOT found: PFVFLOW disabled")
-    ENDIF(ENABLE_PFVFLOW)
-
-  ENDIF(CGAL_FOUND AND GMP_FOUND AND (NOT("${CMAKE_CXX_COMPILER} ${CMAKE_CXX_COMPILER_ARG1}" MATCHES ".*clang")))
-ELSE(ENABLE_CGAL)
-  SET(DISABLED_FEATS "${DISABLED_FEATS} CGAL")
-ENDIF(ENABLE_CGAL)
-#===========================================================
-IF(ENABLE_LINSOLV)
-  FIND_PACKAGE(Cholmod)
-  FIND_PACKAGE(OpenBlas)
-  FIND_PACKAGE(Metis)
-  IF(CHOLMOD_FOUND AND OPENBLAS_FOUND AND METIS_FOUND)
-    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CGAL_DEFINITIONS} -DLINSOLV -DFLOW_ENGINE")
-    SET(LINKLIBS  "${LINKLIBS};${CHOLMOD_LIBRARIES};${AMD_LIBRARY};${CAMD_LIBRARY};${COLAMD_LIBRARY};${CCOLAMD_LIBRARY};${OPENBLAS_LIBRARY};${METIS_LIBRARY}")
-    INCLUDE_DIRECTORIES(${METIS_INCLUDE_DIR} ${CHOLMOD_INCLUDE_DIR})
-    MESSAGE(STATUS "Found Cholmod")
-    MESSAGE(STATUS "Found OpenBlas")
-    MESSAGE(STATUS "Found Metis")
-    SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} LinSolv")
-  ELSE(CHOLMOD_FOUND AND OPENBLAS_FOUND AND METIS_FOUND)
-    MESSAGE(STATUS "Missing dependency for LINSOLV, disabled")
-    SET(DISABLED_FEATS "${DISABLED_FEATS} LinSolv")
-    SET(ENABLE_LINSOLV OFF)
-  ENDIF(CHOLMOD_FOUND AND OPENBLAS_FOUND AND METIS_FOUND)
-ELSE(ENABLE_LINSOLV)
-  SET(DISABLED_FEATS "${DISABLED_FEATS} LinSolv")
-ENDIF(ENABLE_LINSOLV)
-#===============================================
-IF(ENABLE_GL2PS)
-  FIND_PACKAGE(GL2PS)
-  IF(GL2PS_FOUND)
-    INCLUDE_DIRECTORIES(${GL2PS_INCLUDE_DIR})
-    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DYADE_GL2PS")
-    SET(LINKLIBS  "${LINKLIBS};${GL2PS_LIBRARIES};")
-    MESSAGE(STATUS "Found GL2PS")
-    SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} GL2PS")
