=== debian/changelog ===
yade (1.10.0-1~bpo70+1) wheezy-backports; urgency=medium

  * Rebuild for wheezy-backports.
  * Remove python-gts, libmetis-dev, libopenblas-dev, libsuitesparse-dev and
    python-minieigen from Build-Depends.

 -- Anton Gladky <gladk@debian.org>  Fri, 11 Jul 2014 19:23:33 +0200

yade (1.10.0-1) unstable; urgency=medium

  * [431abb8] Imported Upstream version 1.10.0 (Closes: #750318)
  * [3552a3e] Set minimal vtk6 version 6.1.0+dfsg-8.
  * [cd915f6] Set minimal eigen3 version 3.2.1-2.
  * [8e02049] Add autopkgtest-field to control.
  * [38389f8] Remove patches aplied by upstream.

 -- Anton Gladky <gladk@debian.org>  Wed, 25 Jun 2014 20:43:49 +0200

yade (1.07.0-4~bpo70+1) wheezy-backports; urgency=medium

  * Rebuild for wheezy-backports.

 -- Anton Gladky <gladk@debian.org>  Thu, 10 Apr 2014 19:53:56 +0200

yade (1.07.0-4) unstable; urgency=medium

  * [053bf6f] Remove some build-depends, which were added to VTK6.
  * [a560cb6] Remove --parallel option. (Closes: #741827)
  * [1d1f0d5] Build yade only on amd64 hurd-i386 i386 
              kfreebsd-amd64 kfreebsd-i386 powerpc s390x sparc ppc64 x32.
  * [fa8ee56] Add autotest.

 -- Anton Gladky <gladk@debian.org>  Sun, 30 Mar 2014 19:05:22 +0200

yade (1.07.0-3) unstable; urgency=medium

  * [c628d07] Update Depends for VTK6.
  * [2d27ac8] Fix compilation against new libqglviewer.
  * [3821427] Update date in debian/copyright.

 -- Anton Gladky <gladk@debian.org>  Sun, 16 Mar 2014 14:55:57 +0100
