=== debian/control ===
--- 
+++ 
@@ -20,20 +20,15 @@
  libgl1-mesa-dev,
  libgts-dev,
  libloki-dev,
- libmetis-dev [amd64 i386 ia64 kfreebsd-amd64 kfreebsd-i386 powerpc],
- libopenblas-dev [amd64 i386 ia64 kfreebsd-amd64 kfreebsd-i386 powerpc],
- libqglviewer-dev,
- libsuitesparse-dev [amd64 i386 ia64 kfreebsd-amd64 kfreebsd-i386 powerpc],
+ libqglviewer-qt4-dev,
  libvtk5-dev,
  libxi-dev,
  libxmu-dev,
  pyqt4-dev-tools,
  python-all-dev (>= 2.6.6-3~),
  python-argparse,
- python-gts,
  python-imaging,
  python-matplotlib,
- python-minieigen [!s390],
  python-numpy,
  python-qt4,
  python-support,
@@ -54,9 +49,10 @@
  texlive-xetex,
  tipa
 Standards-Version: 3.9.5
+XS-Testsuite: autopkgtest
 
 Package: yade
-Architecture: any
+Architecture: amd64 hurd-i386 i386 kfreebsd-amd64 kfreebsd-i386 powerpc s390x sparc ppc64 x32 
 Pre-Depends:
  ${misc:Pre-Depends}
 Multi-Arch: foreign
@@ -81,7 +77,7 @@
  This package contains speed-optimized build of yade.
 
 Package: libyade
-Architecture: any
+Architecture: amd64 hurd-i386 i386 kfreebsd-amd64 kfreebsd-i386 powerpc s390x sparc ppc64 x32
 Pre-Depends:
  ${misc:Pre-Depends}
 Multi-Arch: same
@@ -104,7 +100,7 @@
  This package contains yade`s libraries.
 
 Package: python-yade
-Architecture: any
+Architecture: amd64 hurd-i386 i386 kfreebsd-amd64 kfreebsd-i386 powerpc s390x sparc ppc64 x32
 Section: python
 Pre-Depends:
  ${misc:Pre-Depends}
@@ -114,10 +110,8 @@
 Depends:
  libyade (= ${binary:Version}),
  python-argparse,
- python-gts,
  python-imaging,
  python-matplotlib,
- python-minieigen,
  python-qt4,
  python-tk,
  python-xlib,
