=== debian/rules ===
--- 
+++ 
@@ -4,7 +4,7 @@
 tmpDirMatplotLib = $(CURDIR)/debian/matplotlib
 
 %:
-	dh $@ --buildsystem=cmake --builddirectory=$(BUILDDIR) --with python2
+	dh $@ --builddirectory=$(BUILDDIR) --with python2
 
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed,-no-keep-memory
